---
--- Generated by EmmyLua(https://github.com/EmmyLua)
--- Created by THeartnet.
--- DateTime: 8/21/2022 07:51
---
if isClient() then return end
if not isServer() then print("Multiplayer part skipped");
    return;
else
    print("Multiplayer part loaded");
end

-- ZBASE:  x: 3380 y: 11262 z: 0
-- ZCRANE: x: 4129 y: 11278 z: 0

--RESULTS:
-- PASSED WITH: NO CLIENT PART, GetGridSquare at server
-- PASSED WITH: WITH CLIENT PART with GetOrCreateGridSquare, GetGridSquare at server

AT_WorldTurretsList = {};
AT_TurretPistolAmmo = {"Bullets9mm", "Bullets45", "Bullets44", "Bullets38"};
AT_TurretShotgunAmmo = {"ShotgunShells"};
AT_TurretSniperAmmo = {"223Bullets", "308Bullets", "556Bullets"};
AT_TurretAmmoTypes = {["TurretPistol"]=AT_TurretPistolAmmo, ["TurretShotgun"]=AT_TurretShotgunAmmo, ["TurretSniper"]=AT_TurretSniperAmmo};
AT_TurretReloadSeconds = {["TurretPistol"]=0.5, ["TurretShotgun"]=2, ["TurretSniper"]=2.5};
AT_TurretShootingRadius = {["TurretPistol"]=10, ["TurretShotgun"]=5, ["TurretSniper"]=20};

local turretOperativeRange = 100;
--[[local currentTick = 0;
local tickToTrigger = 5;]]
-- if the square has a turret and the turret is not on the list, add to the list.
function AT_OnLoadTurretSquare(turretSquare)
    if not turretSquare then return end
    local turret = AT_CheckSquareHasTurret(turretSquare);
    if turret then
        if AT_CheckTurretSquareNotInList(turretSquare) == true then
            local turretSquareTable = AT_GetSquareTable(turretSquare);
            table.insert(AT_WorldTurretsList, turretSquareTable);
            print("Yo, turelko established: "..tostring(turretSquareTable));
        end
    end
end
-- check if the turret's square is in the list
function AT_CheckTurretSquareNotInList(turretSquare)
    if not turretSquare then
        return;
    end

    local squareTable = AT_GetSquareTable(turretSquare);
    local notInList = true;
    for k,v in ipairs(AT_WorldTurretsList) do
        if v.x == squareTable.x and v.y == squareTable.y and v.z == squareTable.z then
            notInList = false;
            break
        end
    end
    return notInList;
end
-- get the square table for the list
function AT_GetSquareTable(square)
    if not square then return end
    local squareTable = {x = square:getX(), y = square:getY(), z = square:getZ()};
    return squareTable;
end
-- when an object added to the world, check if it's a turret(Thumpable)
function AT_OnTurretPlaced(turret)
    if not turret then return end
    if instanceof(turret, "IsoThumpable") then
        local turretSquare = turret:getSquare();
        AT_OnLoadTurretSquare(turretSquare);
    end
end

-- main turret update
function DoZTurretJob()
    --[[currentTick = currentTick + 1;
    if (currentTick < tickToTrigger) then return end
    currentTick = 0;]]

    AT_CheckTurretStillExist();
end

-- every tick, check if the square in the list still has the turret or not
function AT_CheckTurretStillExist()
    for k,v in ipairs(AT_WorldTurretsList) do
        if v then
            local square = getCell():getOrCreateGridSquare(v.x, v.y, v.z);
            if not square then
                return;
            end
            local turret = AT_CheckSquareHasTurret(square);
            if turret == nil then
                table.remove (AT_WorldTurretsList, k);
            else
                AT_TurretUpdate(turret);
            end
        end
    end
end
-- check if the square has a turret
function AT_CheckSquareHasTurret(turretSquare)
    if not turretSquare then return end
    local squareObjects = turretSquare:getObjects();
    local result = nil;
    for i = 0, squareObjects:size()-1 do
        local obj = squareObjects:get(i);
        local itemContainer = obj:getContainer();
        if itemContainer ~= nil then
            local containerType = itemContainer:getType();
            if string.sub(containerType, 1, 6) == "Turret" then
                --print("Turret Detected: "..containerType);
                --print("Capacity: "..tostring(itemContainer:getCapacity()));
                result = obj;
                break;
            end
        end
    end

    return result;
end
-- update turrets vision, reload, send attack command to client, consume ammo.
function AT_TurretUpdate(turret)
    if not turret then return end
    if turret:getModData().ATreloadtime == nil then
        turret:getModData().ATreloadtime = 0.0;
    end

    if turret:getModData().AT_AimingTime == nil then
        turret:getModData().AT_AimingTime = 0.0;
    end

    if turret:getModData().ATreloadtime > 0.0 then
        turret:getModData().ATreloadtime = turret:getModData().ATreloadtime - getGameTime():getRealworldSecondsSinceLastUpdate();
        turret:getModData().AT_AimingTime = turret:getModData().AT_AimingTime - getGameTime():getRealworldSecondsSinceLastUpdate();
        return;
    end

    if turret:getModData().AT_AimingTime > 0.0 then
        turret:getModData().AT_AimingTime = turret:getModData().AT_AimingTime - getGameTime():getRealworldSecondsSinceLastUpdate();
        return;
    end

    turret:getModData().AT_AimingTime = ZombRandFloat(0.1, 0.4);
    local ammo = AT_GetAmmoInTurret(turret);
    if not ammo then
        return;
    end

    local tableSquares = AT_GetTableTurretRange(turret);
    local targetSquare = AT_TurretFindTarget(turret, tableSquares);

    --return if target not found
    if not targetSquare then
        return;
    end

    local playersConnected = getNumActivePlayers();
    if playersConnected == 0 then
        --print("No players connected");
        return;
    end

    local chosenPlayer = GetNeo(turret:getX(), turret:getY());

    if chosenPlayer == nil then
        print("Chosen Player not found");
        return;
    end

    local comboCords = {targetSquare:getX(), targetSquare:getY(), targetSquare:getZ(), turret:getX(), turret:getY(), turret:getZ()};
    sendServerCommand(chosenPlayer, "On_TargetFound", "true", comboCords);
    print("Server command sent");

    turret:getModData().ATreloadtime = AT_TurretReloadSeconds[turret:getContainer():getType()] + ZombRandFloat(0.0, 0.3);
    --print("Sent to reloading state: "..tostring(turret));
end
--looking for Neo
function GetNeo(x, y)
    local onlinePlayers = getOnlinePlayers();
    local zNeo = nil;

    for i = 0, onlinePlayers:size() -1, 1 do
        local potentialNeo = onlinePlayers:get(i);

        local absX = round(potentialNeo:getX());
        local absY = round(potentialNeo:getY());

        local xMin = absX - turretOperativeRange;
        local xMax = absX + turretOperativeRange;
        local yMin = absY - turretOperativeRange;
        local yMax = absY + turretOperativeRange;

        if (x >= xMin and x <= xMax) and (y >= yMin and y <= yMax) then
            zNeo = potentialNeo;
            break;
        end
    end

    return zNeo;
end

-- check and return if the turret has the right ammo inside
function AT_GetAmmoInTurret(turretobj)
    local ammo = nil;

    local turret = turretobj:getContainer();
    if turret then
        if (turret:getCapacity() >= 25) then
            -- titan detected
            --print("Titan detected");
            ammo = "titan";
        else
            local ammoTable = AT_TurretAmmoTypes[turret:getType()];
            for key,value in ipairs(ammoTable) do
                ammo = turret:getItemFromType(value);
                if ammo then
                    break;
                end
            end
        end
    end
    return ammo;
end
-- get the turrets range/vision
function AT_GetTableTurretRange(turret)
    local squareTable = {};
    local tSquare = turret:getSquare();
    if not tSquare then return end
    local tX = tSquare:getX();
    local tY = tSquare:getY();
    local tZ = tSquare:getZ();
    local tType = turret:getContainer():getType();
    local radius = AT_TurretShootingRadius[tType];
    local facing = AT_GetTurretFacing(turret);
    local minX = tX - radius;
    local maxX = tX + radius;
    local minY = tY - radius;
    local maxY = tY + radius;

    local minZ = 0;
    local maxZ = 0;

    -- all turrets are able to shoot on its own z level
    -- sniper turret additionally could shoot 2 level lower than it is placed on
    if (tZ > 0) then
        if tType == "TurretSniper" then
            minZ = tZ - 2;
            maxZ = tZ;
        else
            minZ = tZ;
            maxZ = tZ;
        end
    end

    if minZ < 0 then
        minZ = 0;
    end

    if facing == "S" then
        minY = tY;
    elseif facing == "E" then
        minX = tX;
    elseif facing == "N" then
        maxY = tY;
    elseif facing == "W" then
        maxX = tX;
    end
    for x=minX, maxX do
        for y=minY, maxY do
            for z=minZ,maxZ do
                local LOSTestResults = LosUtil.lineClear(turret:getCell(), tX, tY, tZ, x, y, z, false);
                local tLOS = tostring(LOSTestResults);
                if tLOS == "Clear" or tLOS == "ClearThroughOpenDoor" or tLOS == "ClearThroughWindow" then
                    --local sLOS = getCell():getOrCreateGridSquare(x, y, z);
                    local sLOS = getCell():getGridSquare(x, y, z);
                    if sLOS then
                        table.insert(squareTable, sLOS);
                    end
                end
            end
        end
    end
    return squareTable;
end
-- get turret direction, return "S", "E", "N", "W"
function AT_GetTurretFacing(turret)
    local properties = turret:getProperties();
    local facing = tostring(properties:Val("Facing"));
    return facing;
end
-- find target in the turrets range
function AT_TurretFindTarget (turret, sTable)
    local targetSquare = nil;
    local zZombieList = nil;
    local squareTable = AT_TableShuffle(sTable);
    local turretSquare = turret:getSquare();
    local tX = turretSquare:getX();
    local tY = turretSquare:getY();
    local tZ = turretSquare:getZ();

    for k,v in ipairs(squareTable) do
        if v then
            local zCell = v:getCell();
            if zCell then
                zZombieList = zCell:getZombieList();
                break;
            end
        end
    end

    local zZombieInSightList = {};
    if not zZombieList then
        return;
    end

    if zZombieList and zZombieList:size() <= 0 then
        return;
    end

    --print("Checking InSights");
    for i = 0, zZombieList:size()-1, 1 do
        local zZombie = zZombieList:get(i);
        if zZombie:isDead() == false then
            local zZombieSquare = zZombie:getSquare();
            if zZombieSquare then
                if GetSight(turret, tX, tY, tZ,
                        zZombieSquare:getX(),
                        zZombieSquare:getY(),
                        zZombieSquare:getZ(), false) == true then
                    --print("Zombie found in sight!")
                    --print("Here it is: "..tostring(zZombieList:get(i)));
                    table.insert(zZombieInSightList, zZombieSquare:getID());
                    --print("Pushed into table");
                else
                    --print("No friends in sight");
                end
            end
        else
            --print("Dead-ly zombie detected");
        end
    end

    for k,v in ipairs(squareTable) do
        if v then
            for n,m in ipairs(zZombieInSightList) do
                if m then
                    --print("I see you bitches");
                    if v:getID() == m then
                        --print("I got you bitches");
                        targetSquare = v;
                        break;
                    end
                end
            end
            if targetSquare then break end
        end
    end
    return targetSquare;
end
-- shuffle vision squares table/randomizing
function AT_TableShuffle(tInput)
    local tReturn = {};
    for i = #tInput, 1, -1 do
        local j = ZombRand(i)+1;
        tInput[i], tInput[j] = tInput[j], tInput[i];
        table.insert(tReturn, tInput[i]);
    end
    return tReturn;
end
-- get sight from turret to potential dead
function GetSight(turret, tX, tY, tZ, x, y, z)
    local inSight = false;
    local LOSTestResults = LosUtil.lineClear(turret:getCell(), tX, tY, tZ, x, y, z, false);
    local tLOS = tostring(LOSTestResults);
    if tLOS == "Clear" or tLOS == "ClearThroughOpenDoor" or tLOS == "ClearThroughWindow" then
        --local sLOS = getCell():getOrCreateGridSquare(x, y, z);
        local sLOS = getCell():getGridSquare(x, y, z);
        if sLOS then
            --print("Friend in sight!");
            inSight = true;
        end
    end
    return inSight;
end

local function On_AssassinationInProcessing (module, command, player, args)
    if module ~= "On_AssassinationInProcessing" then return end
    --print("AssassinationInProcessing command received");

    if player then
        --print("Surprise motherfucker, player detected");
    end

    local turretSquare = getCell():getOrCreateGridSquare(args.gunX, args.gunY, args.gunZ);
    if not turretSquare then
        return;
    end

    local chosenPlayer = GetNeo(args.gunX, args.gunY);
    if not chosenPlayer then
        return;
    end

    local neoId = chosenPlayer:getOnlineID();
    --print("Neo Id: "..tostring(neoId));

    --print("MainTarget: "..tostring(args.mainTarget));
    local contractData = {gunX = args.gunX, gunY = args.gunY, gunZ = args.gunZ,
                          zombX = args.zombX, zombY = args.zombY, zombZ = args.zombZ,
                          surTable = args.surTable, mainTarget = args.mainTarget, gunType = args.gunType, neo = neoId};

    sendServerCommand("On_AssassinationContract", "AssassinationContract", contractData);
    --print("AssassinationContract sent");
end

local function On_PremiumAssassinationAccomplished(module, command, player, args)
    if module ~= "On_PremiumAssassinationAccomplished" then return end
    --print("PremiumAssassinationAccomplished command received");

    local turretSquare = getCell():getOrCreateGridSquare(args.gunX, args.gunY, args.gunZ);
    local zTurret = AT_CheckSquareHasTurret(turretSquare);
    if not zTurret then
        --print("Turelko connection lost...");
        return;
    end

    local ammo = AT_GetAmmoInTurret(zTurret);

    if ammo and ammo ~= "titan" then
        zTurret:getContainer():Remove(ammo);
        local memorialData = {x = args.gunX, y = args.gunY, z = args.gunZ};

        sendServerCommand("On_JobDone", "WellDone", memorialData);
        --print("Ammo sacrificed");
    else
        --print("Titan on duty!");
    end
end


Events.OnObjectAdded.Add(AT_OnTurretPlaced);
Events.LoadGridsquare.Add(AT_OnLoadTurretSquare);
Events.OnTick.Add(DoZTurretJob);
Events.OnClientCommand.Add(On_AssassinationInProcessing);
Events.OnClientCommand.Add(On_PremiumAssassinationAccomplished);
